{-# OPTIONS_GHC -fplugin UIO #-}
module Test.UIO.MultiModule.Callee where

import Data.IORef

import UIO

--NOTE: It's important that this NOT be marked INLINE; if it is, then the unfolding will be the *unoptimized* code, which will still contain `uniqueState` invocations.  These will be eliminated by the UIO plugin in the caller, which will work correctly, despite the plugin's behavior being unreliable.
callee :: UIO (IORef Int)
callee = do
  r <- timeless $ newIORef 2
  unordered $ atomicModifyIORef' r $ \v -> (v + 5, ())
  unordered $ atomicModifyIORef' r $ \v -> (v + 5, ())
  pure r
